Package org.eclipse.mat.parser

## Interface IIndexBuilder

All Known Implementing Classes:
  `DTFJIndexBuilder`, `HprofIndexBuilder`

    public interface IIndexBuilder

Part of the parser which builds the indexes

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `cancel()` called in case of error to delete any files / close any file handles
`void` `clean​(int[] purgedMapping, IProgressListener listener)` Memory Analyzer has discard unreachable objects, so the parser may need to known the discarded objects
`void` `fill​(IPreliminaryIndex index, IProgressListener listener)` pass1 and pass2 parsing
`void` `init​(File file, String prefix)` initialize with file and prefix (needed for naming conventions)

### Method Detail

#### init

    void init​(File file,
              String prefix)
       throws SnapshotException,
              IOException

initialize with file and prefix (needed for naming conventions)

Parameters:
  `file` - the dump file
  `prefix` - used to build index files
Throws:
  `SnapshotException`
  `IOException`

#### fill

    void fill​(IPreliminaryIndex index,
              IProgressListener listener)
       throws SnapshotException,
              IOException

pass1 and pass2 parsing

Parameters:
  `index` -
  `listener` - for progress and error reporting
Throws:
  `SnapshotException`
  `IOException`

#### clean

    void clean​(int[] purgedMapping,
               IProgressListener listener)
        throws IOException

Memory Analyzer has discard unreachable objects, so the parser may need to known the discarded objects

Parameters:
  `purgedMapping` - mapping from old id to new id, -1 indicates object has been discarded
  `listener` - for progress and error reporting
Throws:
  `IOException`

#### cancel

    void cancel()

called in case of error to delete any files / close any file handles